/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { IdentityProviders } from '../../@coscine/model';
// @ts-ignore
import type { ProjectInvitationResolveDto } from '../../@coscine/model';
// @ts-ignore
import type { UserDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { UserForUpdateDto } from '../../@coscine/model';
// @ts-ignore
import type { UserMergeDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { UserTermsOfServiceAcceptDto } from '../../@coscine/model';
/**
 * SelfApi - axios parameter creator
 * @export
 */
export const SelfApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Accepts the current Terms Of Service for the current authenticated user.
         * @param {UserTermsOfServiceAcceptDto} [userTermsOfServiceAcceptDto] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        acceptCurrentTos: async (userTermsOfServiceAcceptDto?: UserTermsOfServiceAcceptDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self/tos`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(userTermsOfServiceAcceptDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Confirms the email of a user.
         * @param {string} confirmationToken Gets or initializes the confirmation token for user email confirmation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        confirmUserEmail: async (confirmationToken: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'confirmationToken' is not null or undefined
            assertParamExists('confirmUserEmail', 'confirmationToken', confirmationToken)
            const localVarPath = `/api/v2/self/emails`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (confirmationToken !== undefined) {
                localVarQueryParameter['ConfirmationToken'] = confirmationToken;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the current authenticated user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCurrentUser: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Initiates user merging for the current user.
         * @param {IdentityProviders} identityProvider The identity provider from which user data is to be merged.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        initiateUserMerge: async (identityProvider: IdentityProviders, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'identityProvider' is not null or undefined
            assertParamExists('initiateUserMerge', 'identityProvider', identityProvider)
            const localVarPath = `/api/v2/self/identities`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (identityProvider !== undefined) {
                localVarQueryParameter['IdentityProvider'] = identityProvider;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Resolves a project invitation for the authenticated user.
         * @param {ProjectInvitationResolveDto} [projectInvitationResolveDto] The project invitation resolve data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        resolveProjectInvitation: async (projectInvitationResolveDto?: ProjectInvitationResolveDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self/project-invitations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectInvitationResolveDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates the current authenticated user.
         * @param {UserForUpdateDto} [userForUpdateDto] The updated user data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateCurrentUser: async (userForUpdateDto?: UserForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/self`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(userForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SelfApi - functional programming interface
 * @export
 */
export const SelfApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SelfApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Accepts the current Terms Of Service for the current authenticated user.
         * @param {UserTermsOfServiceAcceptDto} [userTermsOfServiceAcceptDto] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async acceptCurrentTos(userTermsOfServiceAcceptDto?: UserTermsOfServiceAcceptDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.acceptCurrentTos(userTermsOfServiceAcceptDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.acceptCurrentTos']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2SelfOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2SelfOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.apiV2SelfOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Confirms the email of a user.
         * @param {string} confirmationToken Gets or initializes the confirmation token for user email confirmation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async confirmUserEmail(confirmationToken: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.confirmUserEmail(confirmationToken, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.confirmUserEmail']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the current authenticated user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCurrentUser(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCurrentUser(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.getCurrentUser']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Initiates user merging for the current user.
         * @param {IdentityProviders} identityProvider The identity provider from which user data is to be merged.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async initiateUserMerge(identityProvider: IdentityProviders, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserMergeDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.initiateUserMerge(identityProvider, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.initiateUserMerge']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Resolves a project invitation for the authenticated user.
         * @param {ProjectInvitationResolveDto} [projectInvitationResolveDto] The project invitation resolve data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async resolveProjectInvitation(projectInvitationResolveDto?: ProjectInvitationResolveDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.resolveProjectInvitation(projectInvitationResolveDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.resolveProjectInvitation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Updates the current authenticated user.
         * @param {UserForUpdateDto} [userForUpdateDto] The updated user data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateCurrentUser(userForUpdateDto?: UserForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateCurrentUser(userForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SelfApi.updateCurrentUser']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * SelfApi - factory interface
 * @export
 */
export const SelfApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SelfApiFp(configuration)
    return {
        /**
         * 
         * @summary Accepts the current Terms Of Service for the current authenticated user.
         * @param {SelfApiAcceptCurrentTosRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        acceptCurrentTos(requestParameters: SelfApiAcceptCurrentTosRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.acceptCurrentTos(requestParameters.userTermsOfServiceAcceptDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SelfOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2SelfOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Confirms the email of a user.
         * @param {SelfApiConfirmUserEmailRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        confirmUserEmail(requestParameters: SelfApiConfirmUserEmailRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.confirmUserEmail(requestParameters.confirmationToken, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the current authenticated user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCurrentUser(options?: RawAxiosRequestConfig): AxiosPromise<UserDtoResponse> {
            return localVarFp.getCurrentUser(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Initiates user merging for the current user.
         * @param {SelfApiInitiateUserMergeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        initiateUserMerge(requestParameters: SelfApiInitiateUserMergeRequest, options?: RawAxiosRequestConfig): AxiosPromise<UserMergeDtoResponse> {
            return localVarFp.initiateUserMerge(requestParameters.identityProvider, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Resolves a project invitation for the authenticated user.
         * @param {SelfApiResolveProjectInvitationRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        resolveProjectInvitation(requestParameters: SelfApiResolveProjectInvitationRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.resolveProjectInvitation(requestParameters.projectInvitationResolveDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates the current authenticated user.
         * @param {SelfApiUpdateCurrentUserRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateCurrentUser(requestParameters: SelfApiUpdateCurrentUserRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateCurrentUser(requestParameters.userForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for acceptCurrentTos operation in SelfApi.
 * @export
 * @interface SelfApiAcceptCurrentTosRequest
 */
export interface SelfApiAcceptCurrentTosRequest {
    /**
     * 
     * @type {UserTermsOfServiceAcceptDto}
     * @memberof SelfApiAcceptCurrentTos
     */
    readonly userTermsOfServiceAcceptDto?: UserTermsOfServiceAcceptDto
}

/**
 * Request parameters for confirmUserEmail operation in SelfApi.
 * @export
 * @interface SelfApiConfirmUserEmailRequest
 */
export interface SelfApiConfirmUserEmailRequest {
    /**
     * Gets or initializes the confirmation token for user email confirmation.
     * @type {string}
     * @memberof SelfApiConfirmUserEmail
     */
    readonly confirmationToken: string
}

/**
 * Request parameters for initiateUserMerge operation in SelfApi.
 * @export
 * @interface SelfApiInitiateUserMergeRequest
 */
export interface SelfApiInitiateUserMergeRequest {
    /**
     * The identity provider from which user data is to be merged.
     * @type {IdentityProviders}
     * @memberof SelfApiInitiateUserMerge
     */
    readonly identityProvider: IdentityProviders
}

/**
 * Request parameters for resolveProjectInvitation operation in SelfApi.
 * @export
 * @interface SelfApiResolveProjectInvitationRequest
 */
export interface SelfApiResolveProjectInvitationRequest {
    /**
     * The project invitation resolve data.
     * @type {ProjectInvitationResolveDto}
     * @memberof SelfApiResolveProjectInvitation
     */
    readonly projectInvitationResolveDto?: ProjectInvitationResolveDto
}

/**
 * Request parameters for updateCurrentUser operation in SelfApi.
 * @export
 * @interface SelfApiUpdateCurrentUserRequest
 */
export interface SelfApiUpdateCurrentUserRequest {
    /**
     * The updated user data.
     * @type {UserForUpdateDto}
     * @memberof SelfApiUpdateCurrentUser
     */
    readonly userForUpdateDto?: UserForUpdateDto
}

/**
 * SelfApi - object-oriented interface
 * @export
 * @class SelfApi
 * @extends {BaseAPI}
 */
export class SelfApi extends BaseAPI {
    /**
     * 
     * @summary Accepts the current Terms Of Service for the current authenticated user.
     * @param {SelfApiAcceptCurrentTosRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public acceptCurrentTos(requestParameters: SelfApiAcceptCurrentTosRequest = {}, options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).acceptCurrentTos(requestParameters.userTermsOfServiceAcceptDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public apiV2SelfOptions(options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).apiV2SelfOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Confirms the email of a user.
     * @param {SelfApiConfirmUserEmailRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public confirmUserEmail(requestParameters: SelfApiConfirmUserEmailRequest, options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).confirmUserEmail(requestParameters.confirmationToken, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the current authenticated user.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public getCurrentUser(options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).getCurrentUser(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Initiates user merging for the current user.
     * @param {SelfApiInitiateUserMergeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public initiateUserMerge(requestParameters: SelfApiInitiateUserMergeRequest, options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).initiateUserMerge(requestParameters.identityProvider, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Resolves a project invitation for the authenticated user.
     * @param {SelfApiResolveProjectInvitationRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public resolveProjectInvitation(requestParameters: SelfApiResolveProjectInvitationRequest = {}, options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).resolveProjectInvitation(requestParameters.projectInvitationResolveDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates the current authenticated user.
     * @param {SelfApiUpdateCurrentUserRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SelfApi
     */
    public updateCurrentUser(requestParameters: SelfApiUpdateCurrentUserRequest = {}, options?: RawAxiosRequestConfig) {
        return SelfApiFp(this.configuration).updateCurrentUser(requestParameters.userForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

